
package p2pserver;

import java.rmi.Naming;

/**
 * Classe che richiede una connessione RMI per la funzione addAuthUser.
 * La richiesta e' fatta in locale dato che un client funge anche da server.
 * (Inserimento di autenticazioni per la connessione tra client in un hashtable)
 */
public class ClientRmiAuthorization {

    public static String user_to_connect;
    public static String pswd_to_connect;

    /**
     * Main. [vedi specifiche della classe]
     * @param args ={ip client da contattare, chiave da inserire, valore da inserire, nome della funzione}
     * @see p2pclient.C2C_RMIFuncConstructor
     */
    public static void main(String[] args) {

        //args[]
        // 0 = ip client da contattare
        // 1 = k
        // 2 = v
        // 3 = SELEZIONA FUNZIONE ("addAuthUser)

        if(args.length<4) return;

        String server= "rmi://"+args[0]+"/C2C_server";

		p2putility.Util.logServer("Using: " + server);

        try{

           p2pclient.C2C_RMIFuncConstructor obj = (p2pclient.C2C_RMIFuncConstructor)Naming.lookup(server);

            if(args[3].toLowerCase().contentEquals("addAuthUser".toLowerCase())){
                obj.addAuthUser(user_to_connect, pswd_to_connect, args[1], args[2]);

            }

        }
        catch (Exception e)
        {
			p2putility.Util.logServer("Client exception: "+ e);
		}
        
    }

}
