package p2pgui;

import p2putility.Config;
import java.awt.Frame;

/**
 * Classe che genera graficamente la finestra di LogOut dal frame Client
 */
public class LogOutFrameClient extends javax.swing.JDialog {
    /** Codice di ritorno della stato - ritorna se viene premuto il bottone Cancel*/
    public static final int RET_CANCEL = 0;
    /** Codice di ritorno della stato - ritorna se viene premuto il bottone OK*/
    public static final int RET_OK = 1;

    /** Costruttore della classe che crea un nuovo form LogOutFrameClient
     * @param parent
     * @param modal
     */
    public LogOutFrameClient(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** Funzione che fornisce lo stato di ritorno della finestra
      * @return RET_OK o RET_CANCEL
      */
    public int getReturnStatus() {
        return returnStatus;
    }

    /**Metodo chiamato dal costruttore per inizializzare la form
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setTitle("P2PFileSystem - Client Log out");
        setName("LogOutFrameClient"); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/LogOut_ico.png"))); // NOI18N
        jLabel1.setText("Vuoi davvero disconnettere il client?");

        okButton.setText("SI");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("NO");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(42, 42, 42)
                .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 70, Short.MAX_VALUE)
                .addComponent(cancelButton, javax.swing.GroupLayout.PREFERRED_SIZE, 62, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(55, 55, 55))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 276, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(okButton)
                    .addComponent(cancelButton))
                .addContainerGap(46, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

     /**
     * Azione da effettuare se avviene la pressione della X per chiudere la finestra
     * @param evt
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

     /**
     * Azioni da effettuare se avviene la pressione del bottone OK:
      * disconnessione del client tramite Funzione RMI che cancella
      * il client dal db e avvisa il server della disconnessione e
      * chiusura del frame ClientFrame
     * @param evt
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        doClose(RET_OK);

        //Funzione RMI che cancella il client dal db e avvisa il server della disconnessione
        p2pgui.ClientFrame.disconnectClient();

        //Chiusura del Frame ClientFrame
        Config.w_clientOpen(false);
        Frame[] f = Frame.getFrames();
        for(int i =0; i< f.length; i++){
            if((f[i].getName()).equals("ClientFrame")&&f[i].isVisible())
                f[i].dispose();
            if(((f[i].getName()).equals("MainFrame")&&(!f[i].isVisible()))&&(!Config.r_serverOpen()))
                System.exit(0);
        }
        
}//GEN-LAST:event_okButtonActionPerformed
    /**
     * Azione da effettuare se avviene la pressione del bottone CANCEL
     * @param evt
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
}//GEN-LAST:event_cancelButtonActionPerformed

    /**
     * Funzione imposta lo stato di ritorno in base a retStatus
     * @param retStatus
     */
    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
}
