package p2pgui;

import p2putility.Config;
import java.awt.Frame;

/**
 * Classe che genera graficamente la finestra di LogOut dal frame Server
 */
public class LogOutFrameServer extends javax.swing.JDialog {
    /** Codice di ritorno della stato - ritorna se viene premuto il bottone Cancel*/
    public static final int RET_CANCEL = 0;
    /** Codice di ritorno della stato - ritorna se viene premuto il bottone OK*/
    public static final int RET_OK = 1;

    /** Costruttore della classe che crea un nuovo form LogOutFrameServer
     * @param parent
     * @param modal
     */
    public LogOutFrameServer(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    /** Funzione che fornisce lo stato di ritorno della finestra
      * @return RET_OK o RET_CANCEL
      */
    public int getReturnStatus() {
        return returnStatus;
    }

    /**Metodo chiamato dal costruttore per inizializzare la form
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setTitle("P2PFileSystem - Log out Server");
        setName("LogOutFrameServer"); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        okButton.setText("SI");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("NO");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 14));
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/LogOut_ico.png"))); // NOI18N
        jLabel1.setText("Vuoi davvero disconnettere il server?");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(42, 42, 42)
                        .addComponent(okButton, javax.swing.GroupLayout.PREFERRED_SIZE, 67, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(78, 78, 78)
                        .addComponent(cancelButton))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 293, Short.MAX_VALUE)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {cancelButton, okButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(26, 26, 26)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cancelButton)
                    .addComponent(okButton))
                .addContainerGap(46, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Azioni da effettuare se avviene la pressione del bottone OK:
     * delete delle tabelle contenenti i riferimenti ai file condivisi
     * e agli utenti collegati, chiusura dell'istanza del DB e
      * chiusura del frame ServerFrame
     * @param evt
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        doClose(RET_OK);
        //Chiusura del Frame ServerFrame
        if(ServerFrame.IDB.isOpen()){
            ServerFrame.IDB.delFileListBy(null, null, null, null, null, null, null, null, null, null);
            ServerFrame.IDB.delUserListBy(null, null, null, null);
            ServerFrame.IDB.close();
        }
        if(ServerFrame.t1.isAlive())
            ServerFrame.t1.stop();
        if(ServerFrame.t2.isAlive())
            ServerFrame.t2.stop();
        Config.w_serverOpen(false);
        Frame[] f = Frame.getFrames();
        for(int i =0; i< f.length; i++){
            if((f[i].getName()).equals("ServerFrame")&&f[i].isVisible())
                f[i].dispose();
            if(((f[i].getName()).equals("MainFrame")&&(!f[i].isVisible()))&&(!Config.r_clientOpen()))
                System.exit(0);
        }
               
    }//GEN-LAST:event_okButtonActionPerformed
    /**
     * Azione da effettuare se avviene la pressione del bottone CANCEL
     * @param evt
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        doClose(RET_CANCEL);
    }//GEN-LAST:event_cancelButtonActionPerformed

     /**
     * Azione da effettuare se avviene la pressione della X per chiudere la finestra
     * @param evt
     */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        doClose(RET_CANCEL);
    }//GEN-LAST:event_closeDialog

    /**
     * Funzione imposta lo stato di ritorno in base a retStatus
     * @param retStatus
     */
    private void doClose(int retStatus) {
        returnStatus = retStatus;
        setVisible(false);
        dispose();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables

    private int returnStatus = RET_CANCEL;
}
