package p2pgui;

import p2putility.Config;
import java.awt.Frame;
import java.util.ArrayList;
import javax.swing.table.DefaultTableModel;

/**
 *
 * Classe che implementa il servizio Server
 */
public class ServerFrame extends javax.swing.JFrame {

    
    //Modalita' debug
    private static boolean detailerr 	= true;//false;//true;
	private static boolean detailok 	= true;//false;//true;
	private static boolean macro 		= true;//false;//true;

    //Variabili di configurazione del db
	private static String userroot = "";
	private static String pswdroot = "";
	private static String dbroot = "";
	private static String pswdp2p = "";
	private static String userp2p = "";
	private static String dbp2p = "";

    public static Thread t1;
    public static Thread t2;

    public static p2pserver.InquireDB IDB;

    /**
     * Costruttore che crea la form ServerFrame,
     * prepara i DB, crea un istanza di InquireDB,
     *  attiva ServerListener e ServerRMI invocando due thread
     * @see p2pserver.PrepareDB_root
     * @see p2pserver.PrepareDB_user
     * @see p2pserver.InquireDB
     * @see p2pserver.ServerListener
     * @see p2pserver.ServerRMI
     */
    @SuppressWarnings({"static-access", "static-access"})
    public ServerFrame() {

        initComponents();

        int again = -1;
        String x = "";
        do
        {
            getRootData();
            try{
                x = p2pserver.Connecttodbms.connect(false, dbroot, userroot, pswdroot).toString();
            }
            catch(Exception e){
                p2putility.Util.logGeneric("DBMS connection error: "+e);
                x = "";
            }

            if(x.length()<1) // null o errore di connessione
            {
                again = javax.swing.JOptionPane.showConfirmDialog(null, "Error in DBMS connection. Try again?", "DBMS error", javax.swing.JOptionPane.YES_NO_OPTION);
                if(again != javax.swing.JOptionPane.YES_OPTION)
                    System.exit(0);
            }

        }while(x.length()<1);

        getP2pData();
		new p2pserver.PrepareDB_root(macro,detailerr,detailok,dbroot,userroot,pswdroot,userp2p,pswdp2p,dbp2p);
		new p2pserver.PrepareDB_user(macro,detailerr,detailok,userp2p,pswdp2p,dbp2p);

        IDB = new p2pserver.InquireDB(macro, dbp2p, userp2p, pswdp2p);

        //Thread per attivare il main di ServerListener
        p2pgui.MultipleThread MT = new p2pgui.MultipleThread();
        MT.dbg = true;
        t1 = new Thread(MT);
        t1.start();


        //Thread per attivare ServerRMI
        p2pserver.ThreadRmiRegistry TRR = new p2pserver.ThreadRmiRegistry();
        TRR.dbg = true;
        t2 = new Thread(TRR);
        t2.start();
       
    }

    /**Metodo chiamato dal costruttore per inizializzare la form
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jButton3 = new javax.swing.JButton();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        jButton4 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();
        jMenuItem2 = new javax.swing.JMenuItem();
        jMenuItem3 = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        jMenuItem4 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("P2PFileSystem - Server");
        setName("ServerFrame"); // NOI18N
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "IP", "USERNAME", "PASSWORD"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        jTable1.setCellSelectionEnabled(true);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(jTable1);
        jTable1.getColumnModel().getColumn(0).setPreferredWidth(20);
        jTable1.getColumnModel().getColumn(1).setPreferredWidth(20);

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel1.setText("Connected clients");

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel3.setText("Client's files");

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Nome File", "ID nodo proprietario", "ID nodo in accesso", "Tipo di accesso"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Integer.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane3.setViewportView(jTable2);

        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/LogOut_ico.png"))); // NOI18N
        jButton1.setText("Log out");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/Refresh_ico.png"))); // NOI18N
        jButton2.setText("Update file list");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel2.setText("P2P File System ");

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/disconnectIcon.png"))); // NOI18N
        jButton3.setText("Disconnect client");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "ID", "IP", "USERNAME", "PASSWORD"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable3.getTableHeader().setReorderingAllowed(false);
        jScrollPane4.setViewportView(jTable3);
        jTable3.getColumnModel().getColumn(0).setPreferredWidth(20);
        jTable3.getColumnModel().getColumn(1).setPreferredWidth(20);

        jTable4.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "File ID", "Name", "Path", "Client ID", "Size", "Date", "Rights", "Insertion time"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jScrollPane5.setViewportView(jTable4);

        jButton4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/Refresh_ico.png"))); // NOI18N
        jButton4.setText("Update Client List");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });

        jMenu1.setText("File");

        jMenuItem1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/LogOut_ico.png"))); // NOI18N
        jMenuItem1.setText("Log out");
        jMenuItem1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem1ActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuItem1);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Action");

        jMenuItem2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/Refresh_ico.png"))); // NOI18N
        jMenuItem2.setText("Update Client list");
        jMenuItem2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem2ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem2);

        jMenuItem3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/disconnectIcon.png"))); // NOI18N
        jMenuItem3.setText("Disconnect client");
        jMenuItem3.setToolTipText("Open");
        jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem3ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem3);
        jMenu2.add(jSeparator1);

        jMenuItem4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/icons/Refresh_ico.png"))); // NOI18N
        jMenuItem4.setText("Update file list");
        jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuItem4ActionPerformed(evt);
            }
        });
        jMenu2.add(jMenuItem4);

        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, 0, 0, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 770, Short.MAX_VALUE)
                            .addComponent(jLabel1)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(456, 456, 456)
                                .addComponent(jButton2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 63, Short.MAX_VALUE)
                                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 594, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 31, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addComponent(jButton3, javax.swing.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                                    .addComponent(jButton4)))
                            .addComponent(jLabel3)))
                    .addComponent(jLabel2))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jLabel2)
                .addGap(18, 18, 18)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGap(84, 84, 84)
                        .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 103, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(41, 41, 41)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(36, 36, 36)
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jScrollPane5, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jButton2, javax.swing.GroupLayout.DEFAULT_SIZE, 44, Short.MAX_VALUE))
                        .addGap(3, 3, 3)))
                .addGap(30, 30, 30))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

     /**
     * Azione effettuata in seguito alla pressione del bottone di LogOut:
     * creazione di un istanza di LogOutFramServer()
     * @param evt
     */
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        LogOutFrameServer l = new LogOutFrameServer(new javax.swing.JFrame(), true);
        l.setLocationRelativeTo(null);
        l.setVisible(true);
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * Azione effettuata in seguito alla pressione del bottone di LogOut dal JMenu:
     * creazione di un istanza di LogOutFramServer()
     * @param evt
     */
    private void jMenuItem1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem1ActionPerformed
        LogOutFrameServer l = new LogOutFrameServer(new javax.swing.JFrame(), true);
        l.setLocationRelativeTo(null);
        l.setVisible(true);
    }//GEN-LAST:event_jMenuItem1ActionPerformed

    /**
     * Azione effettuata in seguito alla pressione del bottone di Update file list:
     * creazione di un istanza di getFileList()
     * @param evt
     */
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        getFileList();
    }//GEN-LAST:event_jButton2ActionPerformed

     /**
     * Azione effettuata in seguito alla pressione del bottone di Update user list
     * dal JMenu: creazione di un istanza di getUserList()
     * @param evt
     */
    private void jMenuItem2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem2ActionPerformed
        getUserList();
    }//GEN-LAST:event_jMenuItem2ActionPerformed

    /**
     * Azioni da effettuare alla chiusura della finestra: cancellazione delle tabelle
     * dal db, chiusura dell'istanza di InquireDB, termine dei thread generati per
     * le classi ServerListener e ServerFrame
     * @param evt
     */
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        if(ServerFrame.IDB.isOpen()){
            ServerFrame.IDB.delFileListBy(null, null, null, null, null, null, null, null, null, null);
            ServerFrame.IDB.delUserListBy(null, null, null, null);
            ServerFrame.IDB.close();
        }
        if(ServerFrame.t1.isAlive())
            ServerFrame.t1.stop();
        if(ServerFrame.t2.isAlive())
            ServerFrame.t2.stop();
        Config.w_serverOpen(false);
        Frame[] f = Frame.getFrames();
        for(int i =0; i< f.length; i++){
            if(((f[i].getName()).equals("MainFrame")&&(!f[i].isVisible()))&&(!Config.r_clientOpen()))
                System.exit(0);
        }
    }//GEN-LAST:event_formWindowClosing

    /**
     * Azioni effettuata in seguito alla pressione del bottone Disconnect Client:
     * disconnessione del client e aggiornamento della tabella.
     * @param evt
     */
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        disconnectClient();
        getFileList();
    }//GEN-LAST:event_jButton3ActionPerformed

     /**
     * Azione effettuata in seguito alla pressione del bottone di Update user list:
     * creazione di un istanza di getUserList()
     * @param evt
     */
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        getUserList();
    }//GEN-LAST:event_jButton4ActionPerformed

    /**
     * Azione effettuata in seguito alla pressione del bottone di Update file list
     * dal JMenu: creazione di un istanza di getFileList()
     * @param evt
     */
    private void jMenuItem4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem4ActionPerformed
        getFileList();
    }//GEN-LAST:event_jMenuItem4ActionPerformed

    /**
     * Azioni effettuata in seguito alla pressione del bottone Disconnect Client
     * dal JMenu: disconnessione del client e aggiornamento della tabella.
     * @param evt
     */
    private void jMenuItem3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuItem3ActionPerformed
       disconnectClient();
       getFileList();
    }//GEN-LAST:event_jMenuItem3ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JMenuItem jMenuItem3;
    private javax.swing.JMenuItem jMenuItem4;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable4;
    // End of variables declaration//GEN-END:variables



    /**
     * Metodo che crea una form in cui inserire username e password di root del dbms,
     * e il nome del db di default.
     */
    private static void getRootData(){
            javax.swing.JLabel label1 = new javax.swing.JLabel("Insert <root> username:");
            javax.swing.JTextField juf = new javax.swing.JTextField();
            javax.swing.JLabel label2 = new javax.swing.JLabel("Insert <root> password:");
            javax.swing.JPasswordField jpf = new javax.swing.JPasswordField();
            javax.swing.JLabel label3 = new javax.swing.JLabel("Insert <root> default DB:");
            javax.swing.JTextField jdf = new javax.swing.JTextField();
            javax.swing.JOptionPane.showConfirmDialog(null,new Object[]{label1,juf , label2, jpf, label3, jdf}, "DBMS <root> Password:", javax.swing.JOptionPane.OK_CANCEL_OPTION,1);
            pswdroot = jpf.getText();
            userroot = juf.getText();
            dbroot = jdf.getText();
            jpf.setText("*****");
    }

    /**
     * Metodo che crea una password random per il nuovo utente che accede al db
     */
    private static void getP2pData(){

    	// User
    	userp2p = p2putility.Config.r_userp2p();
		// DataBase
		dbp2p = p2putility.Config.r_dbp2p();

		// Password (random dynamic)
		pswdp2p = "";

    	int minlen = 7;
    	int maxlen = 9;
    	String charok = "QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm1234567890";

    	int len = minlen + (int)(java.lang.Math.round(java.lang.Math.random()*(maxlen-minlen)));

    	for(int i=0;i<len;i++)
    		pswdp2p += charok.charAt((int)(java.lang.Math.round(java.lang.Math.random()*(charok.length()-1))));
    }

    /**
     * Metodo che tramite IDB ottiene la lista degli utenti collegati
     * e li inserisce nella tabella jTable3
     */
    private void getUserList(){
        DefaultTableModel model1 = (DefaultTableModel)jTable3.getModel();
        model1.setRowCount(0);
        ArrayList listUser = IDB.getUserList(null);

        Object [] obj= new Object [10];

        for(int i=0; i< listUser.size(); i++){
            int j=-1, k =-1;
            ArrayList temp = (ArrayList)listUser.get(i);
            obj[++k] = Integer.parseInt(temp.get(++j).toString());
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            model1.addRow(obj);
        }
        model1.fireTableRowsInserted(0, listUser.size()-1);
    }

    /**
     * Metodo che tramite IDB ottiene la lista dei file condivisi
     * e li inserisce nella tabella jTable4
     */
    private void getFileList(){
        DefaultTableModel model2 = (DefaultTableModel)jTable4.getModel();
        model2.setRowCount(0);
        ArrayList listFile = IDB.getFileList("");

        Object [] obj= new Object [10];

        for(int i=0; i< listFile.size(); i++){
            int j=-1, k =-1;
            ArrayList temp = (ArrayList)listFile.get(i);
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            j++;
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            obj[++k] = temp.get(++j).toString();
            j++; //non inserisco lo stato obj[++k] = stateFromNumToWord(Integer.parseInt(temp.get(++j).toString()));
            obj[++k] = temp.get(++j).toString();
            model2.addRow(obj);
        }
         model2.fireTableRowsInserted(0, listFile.size()-1);
    }

    /**
     * Metodo che disconnette il client selezionato dalla jTable3,
     * eliminando il suo report dallo userDB e tutti i suoi file condivisi 
     * dal fileListDB
     */
    private void disconnectClient(){
         if(jTable3.getSelectedRow()!=-1 && jTable3.getRowCount()>0){

         int indexToRemove = jTable3.getSelectedRow();
         String id = jTable3.getModel().getValueAt(indexToRemove, 0).toString();
         String ip = jTable3.getModel().getValueAt(indexToRemove, 1).toString();
         String user = jTable3.getModel().getValueAt(indexToRemove, 2).toString();
         String pswd = jTable3.getModel().getValueAt(indexToRemove, 3).toString();

         IDB.delUserListBy(id, ip, user, pswd);
         
         DefaultTableModel model = (DefaultTableModel) jTable3.getModel();
         model.removeRow(indexToRemove);
         model.fireTableRowsDeleted(indexToRemove, indexToRemove);

         IDB.delFileListBy(null, null, null, id, null, null, null, null, "0", null);
         p2putility.Util.logGeneric("Client disconnesso");
         
        }
        
   }


}
