package p2pserver;

import javax.swing.JOptionPane;

/**
 * Classe implementata a Thread che permette di lanciare un processo
 * batch/bash che esegue il comando RMIC che crea lo stub del file.
 * Il processo continua in modo autonomo e non rileva errori.
 * Al termine della procedura si attiva il server RMI che utlizza
 * lo stub appena creato.
 * Questo thread puo' restare in esecuzione fino al termine del programma principale.
 * @see p2pserver.ServerRMI
 */
public class ThreadRmiRegistry implements Runnable {

    public static boolean dbg = true;

    /**
     * Implementazione del metodo run che tramite il comando rmi crea lo stub
     * e lo skeleton di ServerRMI e successivamente crea un'istanza di ServerRMI
     *@see p2pserver.ServerRMI
     */
    public void run(){
        try
                {
                    String ap = p2putility.Config.r_currentpath(); //senza spazi e' ok
                    if(ap!=null)
                        if(ap.length()>0)
                            if(ap.contains((CharSequence)" ")) ap = ""; // con no

                    String cp = p2putility.Config.r_classpath();
                    if(cp!=null)
                        if(cp.length()>0)
                            cp = cp.substring(1);

                    String rp = p2putility.Config.r_rmicpath();
                    String np = "p2pserver.ServerRMI";

                    if (dbg) p2putility.Util.logServer(rp+"rmic -classpath "+ap+cp+" -d "+ap+cp+" "+np);

                    Process pr1 = Runtime.getRuntime().exec(rp+"rmic -classpath "+ap+cp+" -d "+ap+cp+" "+np);
     
                }
                catch(Exception e)
                {
                    JOptionPane.showMessageDialog(null,"Errore nell'esecuzione di 'rmic'.\n"+e,"Errore",0);
                    if(dbg) p2putility.Util.logServer("Errore nell'esecuzione di 'rmic'.\n"+e);
                    return;
                }
                finally
                {
                    p2pserver.ServerRMI.main(null);
                }

                return;
    }

}
