package p2pclient;

import java.rmi.*;
import java.util.ArrayList;

/**
 * Classe che implementa il client RMI che si interfaccia a ServerRMI,
 * richiamando le funzione dell'interfaccia RMIFuncConstructor
 * @see p2pserver.ServerRMI
 * @see p2pclient.RMIFuncConstructor
 */
public class clientRMI {

    public static int id_user;
    public static String id_owner;
    public static ArrayList list;
    public static String name_file;
    public static String path_file;
    public static String where = "";
    public static String accessString = "-1";
    public static String id_file;

    public static int deleted;
    public static boolean ison = false;
    public static boolean alive = false;

/**
 * Metodo main che a seconda del nome della funzione inserita,
 * richiama la corrispettiva su serverRMI
 *
 * @param args ip server, username, password, nome funzione
 */
	public static void main(String[] args) {

        //args[]
        // 0 = server ip (127.0.0.1)
        // 1 = username
        // 2 = password
        // 3 = SELEZIONA FUNZIONE (registerToServer)

        if(args.length<4) return;

		String server= "rmi://"+args[0]+"/ServerRMI";
		
		p2putility.Util.logClient("Using " + server);
		
		try {
            RMIFuncConstructor obj =	(RMIFuncConstructor)Naming.lookup(server);

            if(args[3].toLowerCase().contentEquals("registerToServer".toLowerCase())){
                        int conn =obj.registerToServer(args[1], args[2]);
			            p2putility.Util.logClient("Client registrato = "+conn);
                        id_user = conn;
                        if(conn!=-1){
                            p2pgui.ClientFrame.jLabel4.setText("Active connection with server "+server);
                        }
                        else{
                            p2pgui.ClientFrame.jLabel4.setText("No Active connection with server "+server);
                            return;
                        }

            }
            
            else
                if(args[3].toLowerCase().contentEquals("sendList".toLowerCase())){
                    boolean sent = obj.sendList(args[1], args[2], list);

                }
            else
                if(args[3].toLowerCase().contentEquals("removeFile".toLowerCase())){
                    boolean removed = obj.removeFile(args[1], args[2], name_file, path_file, 0);
                    if(!removed){
                        deleted = 0;
                        p2putility.Util.logClient("File "+name_file+" non e' stato rimosso");
                    }
                    else{
                        deleted = 1;
                        p2putility.Util.logClient("File "+name_file+" e' stato rimosso");
                    }
                }
             else
                if(args[3].toLowerCase().contentEquals("getList".toLowerCase())){
                    list = obj.getList(args[1], args[2], where);

                }
            else
                if(args[3].toLowerCase().contentEquals("getAccessStringRead".toLowerCase())){
                    accessString = obj.getAccessStringRead(args[1], args[2], id_owner, id_file);
                    
                }
            else
                if(args[3].toLowerCase().contentEquals("getAccessStringDelete".toLowerCase())){
                    accessString = obj.getAccessStringDelete(args[1], args[2], id_owner, id_file);
                   
                }
            else
                if(args[3].toLowerCase().contentEquals("getAccessStringUpload".toLowerCase())){
                    accessString = obj.getAccessStringUpload(args[1], args[2], id_owner, id_file);

                }
             else
                if(args[3].toLowerCase().contentEquals("getUserList".toLowerCase())){
                    list = obj.getUserList(args[1], args[2], where);
                }
             else
                if(args[3].toLowerCase().contentEquals("serverOn".toLowerCase())){
                    ison = obj.serverOn();
                }
             else
                if(args[3].toLowerCase().contentEquals("clientAlive".toLowerCase())){
                    alive = obj.clientAlive(args[1], args[2]);
                }
            else
                if(args[3].toLowerCase().contentEquals("disconnectClient".toLowerCase())){
                    obj.disconnectClient(args[1], args[2]);
                }
		}
        catch (Exception e)
        {
			p2putility.Util.logClient("Client exception: "+ e);
		}
		
	}

}
